.586
.mmx
.xmm

.model flat,stdcall
option casemap:none

literal_float		MACRO	lit_float:VARARG
			LOCAL	local_float
			.data
local_float		real4	lit_float
			.code
			EXITM	<local_float>
			ENDM

CFLT			MACRO	lit_float:VARARG
			EXITM	<literal_float(lit_float)>
			ENDM

   include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   include shell32.inc
   include comdlg32.inc
   include winmm.inc
   include OpenGL32.inc
   include GLU32.inc
   Include masm32.inc
  	include fFile.inc
   include fMath.inc
   include hNullString.inc
;   include jpeglib.inc
   include Grafik_engine.inc
   include comdlg32.inc
   
   includelib masm32.lib
   includelib gdi32.lib
   includelib user32.lib
   includelib kernel32.lib
   includelib winmm.lib
   includelib shell32.lib
;   includelib jpeglib.lib
	includelib	ole32.lib
	includelib	oleaut32.lib
	includelib comdlg32.lib
	includelib OpenGL32.lib
	includelib GLU32.lib
   
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
onTimer proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
onTimer2 proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
Control proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

InitGame proto :dword

MenuInGame proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
PlayInGame proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

FPS_Count proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

DrawBuilding proto x:dword,y:dword
CreateObject proto x:dword,y:dword,obj:dword


PushButton proto lpText:DWORD,hParent:DWORD,a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,ID:DWORD

 szText MACRO Name, Text:VARARG
        LOCAL lbl
          jmp lbl
            Name db Text,0
          lbl:
        ENDM

.data
   ClassName db "GEF",0
   AppName  db "GEF",0
   
	
	; --- Sphere 1
	; Angles
	Sphere1AnglesFlt	dd	0.0,0.0,0.0
	; Rotations speed
	Sphere1AnglesSpeedFlt	dd	0.0,0.0,0.0
	; Objects datas
	Sphere1Color		dd	0.0,0.0,0.6,0.0
	Sphere1Radius		dq	0.4
	sphere1Parts		dd	36
	Sphere1Position		dd	0.0,0.0,-5.0
	GlSphere1		dd	0
	
	; --- Sphere 2
	; Angles
	Sphere2AnglesFlt	dd	0.0,0.0,0.0
	; Rotations speed
	Sphere2AnglesSpeedFlt	dd	0.0,0.0,0.0
	; Objects datas
	Sphere2Color		dd	0.4,0.0,0.0,0.0
	Sphere2Radius		dq	0.1
	sphere2Parts		dd	36
	Sphere2Position		dd	0.5,-0.01,-1.0
	GlSphere2		dd	0
	
RotX			dd		0.0
RotXSpeed		dd		10.0
RotY			dd		0.0
RotYSpeed		dd		10.0
RotZ			dd		0.0
RotZSpeed		dd		10.0

	; Light position
	LightSourcePosition	dd	-2.0,-2.0,-4.0,0.0
	LightSource2Position	dd	2.0,2.0,4.0,0.0
	LightSource3Position	dd	-2.0,2.0,4.0,0.0
	LightAmbient		dd	0.2,0.0,0.0,1.0
	Light2Ambient		dd	0.0,0.2,0.0,1.0
	Light3Ambient		dd	0.0,0.0,0.2,1.0
	LightDiffuse		dd	1.0,1.0,1.0,1.0
	LightSpecular		dd	1.0,1.0,1.0,1.0
	SpotCut			dd	-1.0
	SpotExp			dd	0.0
	SpotDir			dd	-1.0,-1.0,-1.0
	LightConstAtt		dd	1.0
	LightLinAtt		dd	1.0
	LightQuadAtt		dd	1.0
	
	poly_test 	dd -0.21,0.21,-0.21
				dd 0.21,0.21,-0.21
				dd 0.21, -0.21, -0.21
				dd -0.21,-0.21, -0.21
				
				dd -0.21,0.21,0.21
				dd 0.21,0.21,0.21
				dd 0.21, -0.21, 0.21
				dd -0.21,-0.21, 0.21
								
				
.data?
	hInstance HINSTANCE ?
	CommandLine LPSTR ?
	hwnd dword ?
	wDC dword ?
	
	keybrd_buff dword ?
	
	mx dword ?
	my dword ?
	
	the_rotx dword ?
	the_roty dword ?
	the_rotz dword ?
	
	mtrl1 dword ?
	
	lyr1 dword ?
	lyr2 dword ?
	lyr3 dword ?
	
	mclick dword ?
	
	mouse POINT <?>
	
	
	FPSCounter dword ?
	FPS dword ?
	
	lyr_ogl dword ?
	
	glcube dword ?
	glPoly dword ?
	
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX 
	LOCAL msg:MSG 
	
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW\
           ,0,\
           0,600,600,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc uses esi edi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL tid:dword
	LOCAL t[256]:dword
	LOCAL t2[256]:dword
	LOCAL r:RECT
	
	.IF uMsg==WM_DESTROY
		invoke CoolDownSystem
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		;sys_call db 0fh,05h
		
		; Do not remove this
		invoke GetDC,hWnd
		mov wDC,eax
		invoke fSetDC,wDC
		
		; Phase1 function used for sin cos and tan function.
		; Remove this function if it crash
		invoke Phase1
		
		invoke mAlloc,512
		mov keybrd_buff,eax

		
		invoke SetTimer,hWnd,2,1000,addr FPS_Count
		
		invoke CreateLayerOGL
		.if eax==-1
			invoke MessageBox,hWnd,NULL,NULL,MB_OK
		.endif
		
		invoke InitGame,hWnd
		
	.elseif uMsg==WM_USER
	

	.elseif uMsg==WM_MOUSEMOVE
		invoke InputMouseFrb,lParam
		mov mouse.x,eax
		mov mouse.y,edx
	.elseif uMsg==WM_KEYUP
		mov esi,keybrd_buff
		mov eax,wParam
		mov byte ptr[esi+eax],0
		
	.elseif uMsg==WM_KEYDOWN
	
		mov esi,keybrd_buff
		mov eax,wParam
		mov byte ptr[esi+eax],1
		
	.elseif uMsg==WM_LBUTTONUP
		mov mclick,0
		
	.elseif uMsg==WM_LBUTTONDOWN
		mov mclick,1	
	.ELSE
		
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	
	xor eax,eax
	ret
WndProc endp

IsPressed proc uses esi key:dword

	mov esi,keybrd_buff
	mov eax,key
	movzx eax,byte ptr[esi+eax]
	
	ret
IsPressed endp

SetLightSource		PROC	LtNumber:DWORD,LtPosition:DWORD,LtAmbient:DWORD
			invoke	glLightfv,LtNumber,GL_POSITION,LtPosition
			invoke	glLightfv,LtNumber,GL_DIFFUSE,ADDR LightDiffuse
			invoke	glLightfv,LtNumber,GL_SPECULAR,ADDR LightSpecular
			invoke	glLightfv,LtNumber,GL_AMBIENT,LtAmbient
			invoke	glLightfv,LtNumber,GL_CONSTANT_ATTENUATION,ADDR LightConstAtt
			invoke	glLightfv,LtNumber,GL_LINEAR_ATTENUATION,ADDR LightLinAtt
			invoke	glLightfv,LtNumber,GL_QUADRATIC_ATTENUATION,ADDR LightQuadAtt
			invoke	glLightfv,LtNumber,GL_SPOT_CUTOFF,ADDR SpotCut
			invoke	glLightfv,LtNumber,GL_SPOT_EXPONENT,ADDR SpotExp
			invoke	glLightfv,LtNumber,GL_SPOT_DIRECTION,ADDR SpotDir
			invoke	glEnable,LtNumber
			ret	
SetLightSource		ENDP

InitGame proc hWnd:dword
	; Set Up everything
	invoke InitGL
	
	; Light here
	invoke	SetLightSource,GL_LIGHT1,ADDR LightSource2Position,ADDR Light2Ambient
	invoke	SetLightSource,GL_LIGHT2,ADDR LightSource3Position,ADDR Light3Ambient
	
	; Creating object here
	invoke	CreateSphere,GLU_LINE,GLU_SMOOTH,ADDR Sphere1Color,ADDR Sphere1Radius,sphere1Parts
	mov	GlSphere1,eax
	invoke	CreateSphere,GLU_FILL,GLU_SMOOTH,ADDR Sphere2Color,ADDR Sphere2Radius,sphere2Parts
	mov	GlSphere2,eax
	invoke CreateCube,GLU_FILL,GLU_SMOOTH,addr Sphere2Color,CFLT(0.11)
	mov glcube,eax
	
	invoke CreateObjectByPolygon,addr poly_test,4
	mov glPoly,eax
		
	invoke SetTimer,hWnd,1,1000/50,addr PlayInGame
	ret
InitGame endp



PlayInGame proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL z_p:dword
	LOCAL buff[256]:dword
	LOCAL tmp_esi,tmp_edi:dword
	
	mov tmp_esi,esi
	mov tmp_edi,edi
	
;	invoke GetStockObject,BLACK_BRUSH
;	invoke SelectObject,mDCGUI,eax
;	invoke GetStockObject,BLACK_PEN
;	invoke SelectObject,mDCGUI,eax
	
;	invoke Rectangle,mDCGUI,0,0,1024,768

;	invoke GetStockObject,WHITE_BRUSH
;	invoke SelectObject,mDCGUI,eax
;	invoke GetStockObject,WHITE_PEN
;	invoke SelectObject,mDCGUI,eax
	
	
	invoke DrawGLScene
	
	invoke	glLightfv, GL_LIGHT2, GL_DIFFUSE, addr LightDiffuse
	invoke	glLightfv, GL_LIGHT2, GL_AMBIENT, addr LightAmbient
	invoke	glLightfv, GL_LIGHT1, GL_POSITION, addr LightSourcePosition
	invoke	glLightf, GL_LIGHT1, GL_QUADRATIC_ATTENUATION, CFLT(0.5)
	invoke  glEnable,GL_LIGHT0
	invoke	glEnable, GL_LIGHT1
	invoke	glEnable, GL_LIGHT2
	
	; ________________________
	; Rotation function here
	; ________________________
			fld	dword ptr [RotXSpeed]
			fmul	dword ptr CFLT(0.2)
			fadd	dword ptr [RotX]
			fstp	dword ptr [RotX]

			fld	dword ptr [RotYSpeed]
			fmul	dword ptr CFLT(0.0) 
			fadd	dword ptr [RotY]
			fstp	dword ptr [RotY]

			fld	dword ptr [RotZSpeed]
			fmul	dword ptr CFLT(0.2)
			fadd	dword ptr [RotZ]
			fstp	dword ptr [RotZ]			
	; ______________________________
	; End of rotation function
	; ______________________________
	
	invoke	glPushMatrix
	invoke	glTranslatef, CFLT(0.0), CFLT(0.0), CFLT(-0.1)
	invoke	glRotatef, RotX, CFLT(1.0), CFLT(0.0), CFLT(0.0)
	invoke	glRotatef, RotY, CFLT(0.0), CFLT(1.0), CFLT(0.0)
	invoke	glRotatef, RotZ, CFLT(0.0), CFLT(0.0), CFLT(1.0)
	
;	invoke glPushMatrix
;	invoke	glTranslatef, CFLT(0.0), CFLT(0.0), CFLT(0.1)
;	invoke	glRotatef, RotX, CFLT(1.0), CFLT(0.0), CFLT(0.0)
;	invoke	glRotatef, RotY, CFLT(0.0), CFLT(1.0), CFLT(0.0)
;	invoke	glRotatef, RotZ, CFLT(0.0), CFLT(0.0), CFLT(1.0)


	; glCallList is used for drawing
	invoke glViewport,150,0,600,600
	invoke glCallList,glcube
	
	invoke glViewport,-150,0,600,600
	invoke glCallList,GlSphere1
	
	invoke glViewport,100,150,600,600
	invoke glCallList,GlSphere2
	
	invoke glViewport,50,-200,600,600
	invoke glCallList,glPoly
	
	invoke glPopMatrix
	
	invoke SwapBuffers,wDC
	
	invoke dw2a,FPS,addr buff
	invoke TextOut,wDC,0,100,addr buff,eax
	;invoke BitBlt,wDC,0,0,1024,768,mDCGUI,0,0,SRCCOPY
		
	
	inc FPSCounter
	
	mov edi,tmp_edi
	mov esi,tmp_esi
	ret
PlayInGame endp
; This is the sub function of my program

FPS_Count proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	mov eax,FPSCounter
	mov FPS,eax
	mov FPSCounter,0
	
	ret
FPS_Count endp


end start
