

InitControlFrb proto hWnd:HWND
GetMainScreenAddress proto
GetBitMapAddress proto
GetBitMapHandle proto
GetMainScreenDC proto

CreateMaterial proto w:dword,h:dword

frbPixelPut proto x:dword,y:dword,color:dword
frbPixelPut2 proto x:dword,y:dword,color:dword

fCreateLayer proto hWnd:dword,x:dword,y:dword,w:dword,h:dword
fLayerGetDC proto hndlyr :dword
fLayerGetBmp proto hndlyr :dword
fLayerGetBIH proto hndlyr :dword
fLayerGetBIHHeigth proto hndlyr:dword
fLayerGetBIHWidth proto hndlyr:dword
fLayerGetDimension proto hndlyr:dword
fLayerGetBitmapPointer proto hndlyr:dword
fDestroyLayer proto hndlyr:dword

Line proto x:dword,y:dword,x2:dword,y2:dword,color:dword
Line2 proto x:dword,y:dword,x2:dword,y2:dword,color:dword
fGradientRect proto x:dword,y:Dword,w:dword,h:dword,color:dword
TransferPixel proto dest:dword,sou:dword,machine_used:dword
TransferPixelFull proto
BlankScreen proto

advFrbPixelBuffer proto x:dword,y:dword,color:dword,nCommand:dword
RotateObject PROto ListNumber:DWORD,XYZPosition:DWORD,XYZRotations:DWORD,XYZAngles:DWORD


; system screen
GetBitmapPointer proto
SetBitmapPointer proto :Dword

; fBitmap
CreatefBitmap proto w:dword,h:dword
DestroyfBitmap proto :dword

; OpenGL function
SetLightSource		PROto	LtNumber:DWORD,LtPosition:DWORD,LtAmbient:DWORD

MU_EAX equ 0
MU_MMX equ 1
MU_XMM equ 2

CMND_NORMAL equ 0
CMND_TRANSPARENT equ 1
CMND_ANTIALIAS equ 2

PFD_DRAW_TO_BITMAP equ 8
PFD_MAIN_PLANE		equ	0
PFD_TYPE_COLORINDEX	equ	1
PFD_TYPE_RGBA		equ	0
PFD_DOUBLEBUFFER	equ	1
PFD_DRAW_TO_WINDOW	equ	4
PFD_SUPPORT_OPENGL	equ	020h
PFD_SUPPORT_GDI	equ 16

_100d0	equ 1079574528
_100d1  equ 0		;100.0
_01d0	equ 1069128089		 
_01d1   equ -1717986918 ;0.1
_45d0	equ 40468000h ;45.0
_45d1   equ 0	
_1d0	equ 1072693248
_1d1	equ 0 		;1.0
_05	equ 1056964608  ; 0.5

.data?
	prosesor_type dword ?
	main_screen dword ?
	mscr_x dword ?
	mscr_y dword ?
	mscr_bit dword ?
	mDCGUI dword ?
	hBmpGUI dword ?
	mDCGUI2 dword ?
	hBmpGUI2 dword ?
	pointer_bitmap dword ?
	pointer_bitmap2 dword ?
	
	bih BITMAPINFOHEADER <?>
	
	
	hDC dword ?
	
.data
	FontStrucGUI	LOGFONT <-15,0,0,0,FW_NORMAL,0,0,0,DEFAULT_CHARSET,OUT_STROKE_PRECIS,CLIP_DEFAULT_PRECIS,DRAFT_QUALITY,DEFAULT_PITCH+FF_SWISS,'Lucida Console'>
	frbsnd db 'waveaudio',0
	expl db '/Sound/explosion.wav',0
	bmb db '/Sound/Bomb.wav',0
	plsm db '/Sound/plasma.wav',0
	
	; Some values
	Value0Flt		dd	0.0
	Value1Flt		dd	1.0
	Value1Dbl		dq	1.0
	Value45Dbl		dq	45.0
	Value3Dbl		dq	3.0
	Value7Dbl		dq	7.0
	

	
	center dd 0.0,0.0,0.0
	
.code

; Use mDCGUI2 for manipulating pixel
; Copy it to mDCGUI after finish

; OpenGL render



InitGL	proc 
	
	invoke	glEnable,GL_DEPTH_TEST
	invoke	glEnable,GL_LIGHTING
	invoke	glEnable,GL_CULL_FACE		; Don't render back faces
	invoke	glShadeModel,GL_SMOOTH
	invoke	glEnable,GL_NORMALIZE
	
	invoke glHint,GL_NICEST,GL_PERSPECTIVE_CORRECTION_HINT
	
	xor  eax,eax
	ret
InitGL	endp


DrawGLScene proc 
	push  (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT)
	call glClear
	call glLoadIdentity
	xor eax,eax
	ret
DrawGLScene endp	


ResizeObject		PROC	ParentW:DWORD,ParentH:DWORD
			invoke	glViewport,0,0,ParentW,ParentH
			invoke	glMatrixMode,GL_PROJECTION
			invoke	glLoadIdentity
			invoke	gluPerspective,DWORD PTR Value45Dbl,DWORD PTR Value45Dbl+4,DWORD PTR Value1Dbl,DWORD PTR Value1Dbl+4,DWORD PTR Value3Dbl,DWORD PTR Value3Dbl+4,DWORD PTR Value7Dbl,DWORD PTR Value7Dbl+4
			invoke	glMatrixMode,GL_MODELVIEW
			invoke	glLoadIdentity
			ret
ResizeObject		ENDP



CreateObjectByPolygon proc uses esi edi lppoly:dword,nCount:dword
	LOCAL lst_Poly,tmp_ecx,tmp_edx:dword
		
	cmp lppoly,0
	jnz @f
		ret
	@@:
	cmp nCount,0
	jnz @f
		ret
	@@:
	invoke	glGenLists, 1
	mov	lst_Poly,eax	

	invoke glNewList,lst_Poly,GL_COMPILE
	invoke glShadeModel,GL_SMOOTH
	invoke glBegin,GL_QUADS
	
	
	mov ecx,nCount
	mov esi,lppoly
	xor edx,edx
	@@:
	mov tmp_ecx,ecx
	mov tmp_edx,edx
		invoke glVertex3f,[esi+edx],[esi+edx+4],[esi+edx+8]
	mov edx,tmp_edx	
	mov ecx,tmp_ecx
	add edx,12
	dec ecx
	jnz @b
	
	invoke glEnd
	invoke glEndList
	
	mov eax,lst_Poly
	
	
	ret
CreateObjectByPolygon endp


CreateCube proc FillType:dword,NormalsType:dword,color:dword,r:dword
	LOCAL lst_Cube:dword
	LOCAL m_r,p_r:dword
		
		mov eax,CFLT(0.0)
		fldz
		fsub dword ptr[r]
		fstp dword ptr[m_r]
		
		fldz
		fadd dword ptr[r]
		fstp dword ptr[p_r]
		
			; Create a cube
			invoke	glGenLists, 1
			mov	lst_Cube,eax
			
			invoke	glNewList, eax, GL_COMPILE
				invoke	glBegin, GL_QUADS
					invoke	glMaterialfv,GL_FRONT,GL_AMBIENT_AND_DIFFUSE,color
					
					invoke	glNormal3f, CFLT(0.0), CFLT(0.0), CFLT(1.0)
					invoke	glVertex3f, m_r, m_r, p_r
					invoke	glVertex3f, p_r, m_r, p_r
					invoke	glVertex3f, p_r, p_r, p_r
					invoke	glVertex3f, m_r,  p_r, p_r
	
					invoke	glNormal3f, CFLT(0.0), CFLT(0.0), CFLT(-1.0)
					invoke	glVertex3f, m_r, m_r, m_r
					invoke	glVertex3f, m_r,  p_r, m_r
					invoke	glVertex3f, p_r,  p_r, m_r
					invoke	glVertex3f, p_r, m_r, m_r
	
					invoke	glNormal3f, CFLT(0.0), CFLT(1.0), CFLT(0.0)
					invoke	glVertex3f, m_r,  p_r, m_r
					invoke	glVertex3f, m_r,  p_r, p_r
					invoke	glVertex3f, p_r,  p_r, p_r
					invoke	glVertex3f, p_r,  p_r, m_r
	
					invoke	glNormal3f, CFLT(0.0), CFLT(-1.0), CFLT(0.0)
					invoke	glVertex3f, m_r, m_r, m_r
					invoke	glVertex3f, p_r, m_r, m_r
					invoke	glVertex3f, p_r, m_r, p_r
					invoke	glVertex3f, m_r, m_r, p_r
	
					invoke	glNormal3f, CFLT(1.0), CFLT(0.0), CFLT(0.0)	
					invoke	glVertex3f, p_r, m_r, m_r
					invoke	glVertex3f, p_r, p_r, m_r
					invoke	glVertex3f, p_r, p_r, p_r
					invoke	glVertex3f, p_r, m_r, p_r
	
					invoke	glNormal3f, CFLT(-1.0), CFLT(0.0), CFLT(0.0)
					invoke	glVertex3f, m_r, m_r, m_r
					invoke	glVertex3f, m_r, m_r, p_r
					invoke	glVertex3f, m_r, p_r, p_r
					invoke	glVertex3f, m_r, p_r, m_r
				invoke	glEnd
			invoke	glEndList
			
	mov eax,lst_Cube
	
	ret
CreateCube endp

CreateSphere proc FillType:DWORD,NormalsType:DWORD,Color:DWORD,Radius:DWORD,Parts:DWORD
			LOCAL	GlSphere:DWORD
			LOCAL lst_sph:dword
			
			invoke	glGenLists, 1
			mov lst_sph,eax
			invoke	glNewList,eax,GL_COMPILE
			; Create a template
			invoke	gluNewQuadric
			mov	GlSphere,eax
			; Set object draw style
			invoke	gluQuadricDrawStyle,GlSphere,FillType
			; Set normals style
			invoke	gluQuadricNormals,GlSphere,NormalsType
			; Set object color
			invoke	glMaterialfv,GL_FRONT,GL_AMBIENT_AND_DIFFUSE,Color
			mov	eax,Radius
			; Create a sphere primitive
			invoke	gluSphere,GlSphere,[eax],[eax+4],Parts,Parts
			invoke	glEndList
		;	mov	eax,GlSphere
			mov eax,lst_sph
			
			ret	
	ret
CreateSphere endp



; OpenGL ends here
;-----------------
;-----------------

NewLayer proc l:dword,t:Dword
	LOCAL mdc:Dword
	LOCAL mbmp:dword
	
	invoke CreateCompatibleDC,hDC
	mov mdc,eax
	invoke CreateCompatibleBitmap,hDC,l,t
	mov mbmp,eax
	
	invoke SelectObject,mdc,eax
	
	mov edx,mdc
	mov eax,mbmp
	
	
	ret
NewLayer endp

CreateLayerOGL proc
	LOCAL PF:PIXELFORMATDESCRIPTOR
	LOCAL dDC,PFH,OpenDC,dBmp:Dword
	
;	invoke NewLayer,600,600
;	mov dDC,edx
;	mov dBmp,eax
	
	mov PF.nSize,sizeof PF
	mov PF.nVersion,1
	mov	PF.dwFlags,PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL  or PFD_DOUBLEBUFFER
	mov	PF.dwLayerMask,PFD_MAIN_PLANE
	mov	PF.iPixelType,PFD_TYPE_RGBA
	mov	PF.cColorBits,8
	mov	PF.cDepthBits,16
	mov	PF.cAccumBits,0
	mov	PF.cStencilBits,0
	
	invoke ChoosePixelFormat,hDC,addr PF
	mov PFH,eax
	invoke SetPixelFormat,hDC,PFH,addr PF
	or eax,eax
	jz error
	
	invoke wglCreateContext,hDC
	mov OpenDC,eax
	invoke wglMakeCurrent,hDC,eax
	
	mov edx,hDC
	mov eax,OpenDC
	
	ret
	error:
;	invoke DeleteObject,dBmp
;	invoke DeleteDC,dDC
	xor eax,eax
	dec eax
	ret
CreateLayerOGL endp

IsSupportMMX proc
	
   push   ebx                  
    push   ecx
    push   edx

    ; Check feature flag 23 in EDX for MMX support
    mov    eax, 1               
    cpuid                       
    mov    eax, edx           
    shr    eax, 23              
    and    eax, 1                   

    ; Restore registers
    pop    edx                  
    pop    ecx
    pop    ebx
    ret
	
	ret
IsSupportMMX endp

EndMMX proc
	
    emms     ; Allow CPU to use floating point
    ret
	
	ret
EndMMX endp




fSetDC proc wDC:dword
	push wDC
	pop hDC
	ret
fSetDC endp



InitControlFrb proc hWnd:HWND

	LOCAL mDC:dword,hOld:dword 
	LOCAL r:RECT 
	LOCAL Text[1024]:dword 
	LOCAL posX,posY,clr,xc,yc,xc2,yc2,xc3,yc3,xc4,yc4,co:dword 
	LOCAL pbm,PixFormat,tmpDC:dword
	LOCAL WINRect:RECT

	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,(1024*768*4)*2
	mov main_screen,eax
	
	
	invoke GetDC,hWnd
 	mov tmpDC,eax 
	
	invoke CreateCompatibleDC,tmpDC
	mov mDCGUI,eax
	invoke GetClientRect,hWnd,addr r 
	mov eax,1024		;r.right
	mov mscr_x,eax
	mov eax,768			;r.bottom
	mov mscr_y,eax	
	
	mov mscr_bit,32
	
	mov bih.biSize,sizeof BITMAPINFOHEADER
	push 1024
	pop bih.biWidth
	push 768
	pop bih.biHeight
	mov bih.biPlanes,1
	mov bih.biBitCount,32
	mov bih.biCompression,BI_RGB
	mov bih.biSizeImage,0
	mov bih.biXPelsPerMeter,0
	mov bih.biYPelsPerMeter,0
	mov bih.biClrUsed,0
	mov bih.biClrImportant,0
	invoke CreateDIBSection,mDCGUI,addr bih,DIB_RGB_COLORS,addr pointer_bitmap,0,0
	mov hBmpGUI,eax
		
	invoke SelectObject,mDCGUI,hBmpGUI 
	mov hOld,eax
	
	
	
	invoke SetBkMode,mDCGUI,TRANSPARENT 
	invoke SetTextColor,mDCGUI,0FF00h
	invoke CreateFontIndirect,addr FontStrucGUI
	invoke SelectObject,mDCGUI,eax

	invoke ReleaseDC,hWnd,tmpDC
	
	
	invoke GetDC,hWnd
	mov tmpDC,eax 
	
	invoke CreateCompatibleDC,tmpDC
	mov mDCGUI2,eax
	invoke GetClientRect,hWnd,addr r 
	mov eax,1024		;r.right
	mov mscr_x,eax
	mov eax,768			;r.bottom
	mov mscr_y,eax	
	
	mov mscr_bit,32
	
	mov bih.biSize,sizeof BITMAPINFOHEADER
	push 1024
	pop bih.biWidth
	push 768
	pop bih.biHeight
	mov bih.biPlanes,1
	mov bih.biBitCount,32
	mov bih.biCompression,BI_RGB
	mov bih.biSizeImage,0
	mov bih.biXPelsPerMeter,0
	mov bih.biYPelsPerMeter,0
	mov bih.biClrUsed,0
	mov bih.biClrImportant,0
	invoke CreateDIBSection,mDCGUI2,addr bih,DIB_RGB_COLORS,addr pointer_bitmap2,0,0
	mov hBmpGUI2,eax
		
	invoke SelectObject,mDCGUI2,hBmpGUI2
	mov hOld,eax
	
	
	
	invoke SetBkMode,mDCGUI2,TRANSPARENT 
	invoke SetTextColor,mDCGUI2,0FF00h
	invoke CreateFontIndirect,addr FontStrucGUI
	invoke SelectObject,mDCGUI2,eax
	invoke ReleaseDC,hWnd,tmpDC
	 	
	invoke Phase1
	

	
	
	ret
InitControlFrb endp

InputMouseFrb proc lParam:dword
	
		mov eax,lParam
		mov edx,eax
		and eax,0FFFFh
		
		shr edx,16
		
	
	ret
InputMouseFrb endp

; System screen
GetMainScreenAddress proc
	
	mov eax,main_screen
	
	ret
GetMainScreenAddress endp

GetBitmapPointer proc
	
	mov eax,pointer_bitmap
	
	ret
GetBitmapPointer endp

GetBitMapAddress proc
	
	mov eax,pointer_bitmap
	
	ret
GetBitMapAddress endp

GetBitMapHandle proc
	
	mov eax,hBmpGUI
	
	ret
GetBitMapHandle endp

GetMainScreenDC proc
	
	mov eax,mDCGUI
	
	ret
GetMainScreenDC endp

SetBitmapPointer proc bmppnt:dword
	
	mov eax,bmppnt
	mov pointer_bitmap,eax
	
	ret
SetBitmapPointer endp

; Transfer pixel
TransferPixel proc uses esi edi dest:dword,sou:dword,machine_used:dword
	mov esi,sou
	mov edi,dest
	
	mov eax,machine_used
	xor ecx,ecx
	cmp eax,ecx
	jz use_eax
	inc ecx
	cmp eax,ecx
	jz use_mmx
	inc ecx
	cmp eax,ecx
	jz use_xmm
		xor eax,eax
		dec eax
		ret
	; change ecx depend on width resolution used
	use_eax:
		mov ecx,1024*4
		shr ecx,2
		xor edx,edx
		@@:
			mov eax,[esi+edx*4]
			mov [edi+edx*4],eax
		inc edx
		dec ecx
		jnz @b
		
		ret
	use_mmx:
		mov ecx,1024*4
		shr ecx,3
		xor edx,edx
		@@:
			movq mm0,[esi+edx*8]
			movq [edi+edx*8],mm0
		inc edx
		dec ecx
		jnz @b
		
	use_xmm:
		mov ecx,1024*4
		shr ecx,4
		xor edx,edx
		@@:
			movups xmm0,[esi+edx]
			movups [edi+edx],xmm0
		add edx,16
		dec ecx
		jnz @b
		
	ret
TransferPixel endp

TransferPixelFull proc uses esi edi 
	LOCAL dib_mem,mscr_mem:Dword
	LOCAL cntr:dword
	
	mov edi,pointer_bitmap
	mov esi,main_screen
	
	mov dib_mem,edi
	mov mscr_mem,esi
	
	xor edx,edx
	mov cntr,edx
	mov ecx,767
	@@:
	push ecx
		invoke PosCount2,0,ecx
		shl eax,2
		mov edi,dib_mem
		add edi,eax
		invoke PosCount2,0,cntr
		shl eax,2
		mov esi,mscr_mem
		add esi,eax
			invoke TransferPixel,edi,esi,MU_EAX
	pop ecx
	inc cntr
	dec ecx
	jnz @b
		
		
	ret
TransferPixelFull endp


RetrievePixel proc uses esi edi dest:dword,sou:dword,machine_used:dword
	mov esi,sou
	mov edi,dest
	
	mov eax,machine_used
	xor ecx,ecx
	cmp eax,ecx
	jz use_eax
	inc ecx
	cmp eax,ecx
	jz use_mmx
	inc ecx
	cmp eax,ecx
	jz use_xmm
		xor eax,eax
		dec eax
		ret
	; change ecx depend on width resolution used
	use_eax:
		mov ecx,1024*4
		shr ecx,2
		xor edx,edx
		@@:
			mov eax,[edi+edx*4]
			mov [esi+edx*4],eax
		inc edx
		dec ecx
		jnz @b
		
		ret
	use_mmx:
		mov ecx,1024*4
		shr ecx,3
		xor edx,edx
		@@:
			movq mm0,[edi+edx*8]
			movq [esi+edx*8],mm0
		inc edx
		dec ecx
		jnz @b
		
	use_xmm:
		mov ecx,1024*4
		shr ecx,4
		xor edx,edx
		@@:
			movups xmm0,[edi+edx]
			movups [esi+edx],xmm0
		add edx,16
		dec ecx
		jnz @b
	
	ret
RetrievePixel endp

RetrievePixelFull proc uses esi edi 
	LOCAL dib_mem,mscr_mem:Dword
	LOCAL cntr:dword
	
	mov edi,pointer_bitmap
	mov esi,main_screen
	
	mov dib_mem,edi
	mov mscr_mem,esi
	
	xor edx,edx
	mov cntr,edx
	mov ecx,767
	@@:
	push ecx
		invoke PosCount2,0,ecx
		shl eax,2
		mov edi,dib_mem
		add edi,eax
		invoke PosCount2,0,cntr
		shl eax,2
		mov esi,mscr_mem
		add esi,eax
			invoke RetrievePixel,edi,esi,MU_XMM
	pop ecx
	inc cntr
	dec ecx
	jnz @b
		
		
	ret
RetrievePixelFull endp

; Direct draw the screen
frbPixelPut proc uses esi edi x:dword,y:dword,color:dword
	
	mov edi,pointer_bitmap
	mov ecx,768
	sub ecx,y
	invoke PosCount,x,ecx,1024,768
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov edx,color
	mov [edi+eax*4+2],dl
	mov [edi+eax*4+1],dh
	shr edx,16
	mov [edi+eax*4+0],dl
	
	ret
frbPixelPut endp

frbPixelPut2 proc uses esi edi x:dword,y:dword,color:dword
	; This function use look up table.
	; The first PixelPut is still faster than this function
	
	mov edi,pointer_bitmap
	mov ecx,768
	sub ecx,y
	invoke PosCount2,x,ecx
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov edx,color
	mov [edi+eax*4+2],dl
	mov [edi+eax*4+1],dh
	shr edx,16
	mov [edi+eax*4+0],dl
	
	ret
frbPixelPut2 endp

frbPixelGet proc uses esi edi x:dword,y:dword
	
	mov edi,pointer_bitmap
	mov ecx,768
	sub ecx,y
	invoke PosCount,x,ecx,1024,768
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov eax,[edi+eax*4]
	
	ret
frbPixelGet endp

frbPixelGet2 proc uses esi edi x:dword,y:dword
	; This function use look up table.
	; The first PixelPut is still faster than this function
	
	mov edi,pointer_bitmap
	mov ecx,768
	sub ecx,y
	invoke PosCount2,x,ecx
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov eax,[edi+eax*4]	
	ret
frbPixelGet2 endp



; For draw buffer
FrbPixelPut proc uses esi edi x:dword,y:dword,color:dword
	
	mov edi,main_screen
	invoke PosCount,x,y,1024,768
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov edx,color
	mov [edi+eax*4+2],dl ;r
	mov [edi+eax*4+1],dh ;g
	shr edx,16
	mov [edi+eax*4+0],dl ;b
	
	ret
FrbPixelPut endp

FrbPixelPut2 proc uses esi edi x:dword,y:dword,color:dword
	; This function use look up table.
	; The first PixelPut is still faster than this function
	
	mov edi,main_screen
	invoke PosCount2,x,y
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov edx,color
	mov [edi+eax*4+2],dl
	mov [edi+eax*4+1],dh
	shr edx,16
	mov [edi+eax*4+0],dl
	
	ret
FrbPixelPut2 endp

FrbPixelGet proc uses esi edi x:dword,y:dword
	
	mov edi,main_screen
	invoke PosCount,x,y,1024,768
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov dl,[edi+eax*4+0]
	shl edx,16
	mov dh,[edi+eax*4+1]
	mov dl,[edi+eax*4+2]
	
	mov eax,edx
	
	ret
FrbPixelGet endp

FrbPixelGet2 proc uses esi edi x:dword,y:dword
	; This function use look up table.
	; The first PixelPut is still faster than this function
	
	mov edi,main_screen
	invoke PosCount2,x,y
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov eax,[edi+eax*4]	
	ret
FrbPixelGet2 endp


FillScreen proc uses esi edi color:dword

	
	mov edi,main_screen
	mov ecx,(1024*768)
	mov eax,color
	shl eax,8
	bswap eax
	xor edx,edx
	@@:
		mov [edi+edx*4],eax
	inc edx
	dec ecx
	jnz @b
	
	
	ret
FillScreen endp

BlankScreen proc uses esi edi
	
	mov edi,pointer_bitmap
	mov ecx,(1024*768)
	shr ecx,1
	pxor mm0,mm0
	@@:
	movq [edi+ecx*8],mm0
	dec ecx
	jnz @b
	
	
	ret
BlankScreen endp

BlankScreenBuffer proc uses esi edi
	
	invoke GetMainScreenAddress
	mov edi,eax
	mov ecx,(1024*768)
	shr ecx,1
	pxor mm0,mm0
	@@:
	movq [edi+ecx*8],mm0
	dec ecx
	jnz @b
	
	
	ret
BlankScreenBuffer endp
